protected/modules/comment/models/CommentMessage.php
<?php

/**
 * This is the model class for table "comment_message".
 *
 * The followings are the available columns in table 'comment_message':
 * @property integer $id
 * @property integer $user_id
 * @property integer $parent_id
 * @property string $message
 * @property string $time_added
 *
 * The followings are the available model relations:
 * @property UserAccount $user
 * @property CommentMessage $parent
 * @property CommentMessage[] $commentMessages
 */
class CommentMessage extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @param string $className active record class name.
	 * @return CommentMessage the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'comment_message';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('message', 'required', 'except'=>'delete'),
			array('user_id, parent_id', 'numerical', 'integerOnly'=>true),
			array('message', 'length', 'max'=>2056),
			// The following rule is used by search().
			// Please remove those attributes that should not be searched.
			array('id, user_id, parent_id, message, time_added', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
			'user' => array(self::BELONGS_TO, 'UserAccount', 'user_id'),
			'parent' => array(self::BELONGS_TO, 'CommentMessage', 'parent_id'),
			'replies' => array(self::HAS_MANY, 'CommentMessage', 'parent_id'),
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => 'ID',
			'user_id' => 'User',
			'parent_id' => 'Parent',
			'message' => 'Message',
			'time_added' => 'Time Added',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);
		$criteria->compare('user_id',$this->user_id);
		$criteria->compare('parent_id',$this->parent_id);
		$criteria->compare('message',$this->message,true);
		$criteria->compare('time_added',$this->time_added,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}
}

protected/modules/comment/controllers/ViewController.php
<?php

class ViewController extends Controller
{
	public function actionAdd()
	{
            $comment = new CommentMessage;
            $comment->scenario = 'add';
            if(isset($_POST['CommentMessage']))
            {
                $comment->attributes = $_POST['CommentMessage'];
                $comment->user_id = Yii::app()->user->id;
                if($comment->save())
                    $this->redirect (array('/comment/view/index'));
            }
            $this->render('add', array(
                'model'=>$comment
            ));
	}

	public function actionDelete($id)
	{
            $comment = CommentMessage::model()->findByPk((int)$id);
            $comment->scenario='delete';
            $comment->unsetAttributes(array('message'));
            $comment->save();
            $this->redirect(array('/comment/view/index'));
	}

	public function actionIndex()
	{
		$this->render('index');
	}

	public function actionReply($id)
	{
            $comment = new CommentMessage;
            $comment->scenario = 'reply';
            if(isset($_POST['CommentMessage']))
            {
                $comment->attributes = $_POST['CommentMessage'];
                $comment->user_id = Yii::app()->user->id;
                $comment->parent_id = $id;
                if($comment->save())
                    $this->redirect (array('/comment/view/index'));
            }
            $this->render('reply', array(
                'model'=>$comment,
                'repliedComment'=>  CommentMessage::model()->findByPk((int)$id)
            ));
	}

	public function filters()
	{
		return array(
			'accessControl'
		);
	}
        public function accessRules(){
            return array(
                array(
                    'allow',
                    'actions'=>array('index'),
                    'users'=>array('*')                    
                ),
                array(
                    'allow',
                    'actions'=>array('add', 'reply'),
                    'users'=>array('@')                    
                ),
                array(
                    'allow',
                    'actions'=>array('delete'),
                    'users'=>array('admin')
                ),
                array(
                    'deny',
                    'users'=>array('*')
                )
                
            );
        }
        /*
	public function actions()
	{
		// return external action classes, e.g.:
		return array(
			'action1'=>'path.to.ActionClass',
			'action2'=>array(
				'class'=>'path.to.AnotherActionClass',
				'propertyName'=>'propertyValue',
			),
		);
	}
	*/
}

protected/modules/comment/views/view/_comment.php
<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
?>
<div class='comment'>
    <p class="comment-title">
        Comment of&nbsp;<strong><?php echo CHtml::encode($data->user->username); ?> </strong>
        &nbsp;in <i><?php echo CHtml::encode($data->time_added); ?></i>
    </p>
    <?php if(!is_null($data->message)): ?>
        <p class="comment-message"><?php echo CHtml::encode($data->message); ?></p>
    <?php else: ?>
        <p class="comment-message-deleted" style='color: darkred'>[deleted]</p>
    <?php endif; ?>
</div>

protected/modules/comment/views/view/_view.php
<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

?>

<?php echo $this->renderPartial('_comment', $data); ?>
<p>
    <?php echo CHtml::link('Reply', array('view/reply', 'id'=>$data->id)); ?>
    <?php if(Yii::app()->user->name==='admin'): ?>
        <?php echo CHtml::link('Delete', array('view/delete', 'id'=>$data->id), array(
            'confirm'=>'Do you realy want to delete this comment'
        )); ?>
    <?php endif; ?>
</p>
<hr />
<div style='margin-left: 20px'>
<?php
$this->widget('zii.widgets.CListView', array(
    'dataProvider' => new CActiveDataProvider('CommentMessage', array(
        'criteria'=>array(
            'condition'=>"parent_id={$data->id}",
            'order'=>'time_added DESC',
            'with'=>'user'
        )
    )),
    'itemView'=>'_view',
    'emptyText'=>'',
    'enablePagination'=>false,
    'summaryText'=>''
));
?>
</div>

protected/modules/comment/views/view/add.php
<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


$this->pageTitle=Yii::app()->name . ' - Comments';
$this->breadcrumbs=array(
	'Comments'=>array('/comment/view/index'),
        'Add comment'
);

?>

<h1>Add Comment</h1>
<div class='form'>
<?php $form=$this->beginWidget('CActiveForm', array(
    'enableClientValidation'=> TRUE,
    //'focus'=>array($model, 'message')
));?>
    
    <?php echo $form->errorSummary($model); ?>
    <div class='row'>
        <?php echo $form->labelEx($model, 'message'); ?>
        <?php echo $form->textArea($model, 'message'); ?>
        <?php echo $form->error($model, 'message'); ?>
    </div>
    <?php echo CHtml::submitButton('Add'); ?>
<?php $this->endWidget(); ?>
</div>

protected/modules/comment/views/view/index.php
<?php
/* @var $this ViewController */

$this->breadcrumbs=array(
	'Comments',
);
?>
<h1>Comments</h1>
<p class="comment-add"><?php echo CHtml::link('Add comment', array('view/add')); ?></p>
<?php
$this->widget('zii.widgets.CListView', array(
    'dataProvider' => new CActiveDataProvider('CommentMessage', array(
        'criteria'=>array(
            'condition'=>'parent_id IS NULL',
            'order'=>'time_added DESC',
            'with'=>'user'
        )
    )),
    'itemView'=>'_view'
));
?>

protected/modules/comment/views/view/reply.php
<?php
/* @var $this ViewController */

$this->pageTitle=Yii::app()->name . ' - Comments';
$this->breadcrumbs=array(
	'Comments'=>array('/comment/view/index'),
        'Reply comment'
);
?>
<h1>Reply comment</h1>
<?php $this->renderPartial('_comment', $repliedComment) ?>
<div class='form'>
<?php $form=$this->beginWidget('CActiveForm', array(
    'enableClientValidation'=> TRUE,
    //'focus'=>array($model, 'message')
));?>
    
    <?php echo $form->errorSummary($model); ?>
    <div class='row'>
        <?php echo $form->labelEx($model, 'message'); ?>
        <?php echo $form->textArea($model, 'message'); ?>
        <?php echo $form->error($model, 'message'); ?>
    </div>
    <?php echo CHtml::submitButton('Add'); ?>
<?php $this->endWidget(); ?>
</div>